Index: lemon/path.h
===================================================================
--- lemon/path.h	(revision 559)
+++ lemon/path.h	(revision 517)
@@ -41,5 +41,5 @@
   ///
   /// A structure for representing directed path in a digraph.
-  /// \tparam GR The digraph type in which the path is.
+  /// \tparam _Digraph The digraph type in which the path is.
   ///
   /// In a sense, the path can be treated as a list of arcs. The
@@ -53,9 +53,9 @@
   /// implementation uses two vectors for storing the front and back
   /// insertions.
-  template <typename GR>
+  template <typename _Digraph>
   class Path {
   public:
 
-    typedef GR Digraph;
+    typedef _Digraph Digraph;
     typedef typename Digraph::Arc Arc;
 
@@ -138,5 +138,5 @@
     /// \brief The nth arc.
     ///
-    /// \pre \c n is in the <tt>[0..length() - 1]</tt> range.
+    /// \pre n is in the [0..length() - 1] range
     const Arc& nth(int n) const {
       return n < int(head.size()) ? *(head.rbegin() + n) :
@@ -146,5 +146,5 @@
     /// \brief Initialize arc iterator to point to the nth arc
     ///
-    /// \pre \c n is in the <tt>[0..length() - 1]</tt> range.
+    /// \pre n is in the [0..length() - 1] range
     ArcIt nthIt(int n) const {
       return ArcIt(*this, n);
@@ -229,5 +229,5 @@
   ///
   /// A structure for representing directed path in a digraph.
-  /// \tparam GR The digraph type in which the path is.
+  /// \tparam _Digraph The digraph type in which the path is.
   ///
   /// In a sense, the path can be treated as a list of arcs. The
@@ -241,9 +241,9 @@
   /// then the \c Path type because it use just one vector for the
   /// arcs.
-  template <typename GR>
+  template <typename _Digraph>
   class SimplePath {
   public:
 
-    typedef GR Digraph;
+    typedef _Digraph Digraph;
     typedef typename Digraph::Arc Arc;
 
@@ -330,5 +330,5 @@
     /// \brief The nth arc.
     ///
-    /// \pre \c n is in the <tt>[0..length() - 1]</tt> range.
+    /// \pre n is in the [0..length() - 1] range
     const Arc& nth(int n) const {
       return data[n];
@@ -393,5 +393,5 @@
   ///
   /// A structure for representing directed path in a digraph.
-  /// \tparam GR The digraph type in which the path is.
+  /// \tparam _Digraph The digraph type in which the path is.
   ///
   /// In a sense, the path can be treated as a list of arcs. The
@@ -405,9 +405,9 @@
   /// time. The front and back insertion and erasure is O(1) time
   /// and it can be splited and spliced in O(1) time.
-  template <typename GR>
+  template <typename _Digraph>
   class ListPath {
   public:
 
-    typedef GR Digraph;
+    typedef _Digraph Digraph;
     typedef typename Digraph::Arc Arc;
 
@@ -508,5 +508,5 @@
     ///
     /// This function looks for the nth arc in O(n) time.
-    /// \pre \c n is in the <tt>[0..length() - 1]</tt> range.
+    /// \pre n is in the [0..length() - 1] range
     const Arc& nth(int n) const {
       Node *node = first;
@@ -733,5 +733,5 @@
   ///
   /// A structure for representing directed path in a digraph.
-  /// \tparam GR The digraph type in which the path is.
+  /// \tparam _Digraph The digraph type in which the path is.
   ///
   /// In a sense, the path can be treated as a list of arcs. The
@@ -747,9 +747,9 @@
   /// it is intented to be
   /// used when you want to store a large number of paths.
-  template <typename GR>
+  template <typename _Digraph>
   class StaticPath {
   public:
 
-    typedef GR Digraph;
+    typedef _Digraph Digraph;
     typedef typename Digraph::Arc Arc;
 
@@ -834,5 +834,5 @@
     /// \brief The nth arc.
     ///
-    /// \pre \c n is in the <tt>[0..length() - 1]</tt> range.
+    /// \pre n is in the [0..length() - 1] range
     const Arc& nth(int n) const {
       return arcs[n];
Index: lemon/preflow.h
===================================================================
--- lemon/preflow.h	(revision 581)
+++ lemon/preflow.h	(revision 492)
@@ -33,6 +33,6 @@
   /// Default traits class of Preflow class.
   /// \tparam GR Digraph type.
-  /// \tparam CAP Capacity map type.
-  template <typename GR, typename CAP>
+  /// \tparam CM Capacity map type.
+  template <typename GR, typename CM>
   struct PreflowDefaultTraits {
 
@@ -44,5 +44,5 @@
     /// The type of the map that stores the arc capacities.
     /// It must meet the \ref concepts::ReadMap "ReadMap" concept.
-    typedef CAP CapacityMap;
+    typedef CM CapacityMap;
 
     /// \brief The type of the flow values.
@@ -95,7 +95,6 @@
   ///
   /// This class provides an implementation of Goldberg-Tarjan's \e preflow
-  /// \e push-relabel algorithm producing a \ref max_flow
-  /// "flow of maximum value" in a digraph.
-  /// The preflow algorithms are the fastest known maximum
+  /// \e push-relabel algorithm producing a flow of maximum value in a
+  /// digraph. The preflow algorithms are the fastest known maximum
   /// flow algorithms. The current implementation use a mixture of the
   /// \e "highest label" and the \e "bound decrease" heuristics.
@@ -107,12 +106,12 @@
   ///
   /// \tparam GR The type of the digraph the algorithm runs on.
-  /// \tparam CAP The type of the capacity map. The default map
+  /// \tparam CM The type of the capacity map. The default map
   /// type is \ref concepts::Digraph::ArcMap "GR::ArcMap<int>".
 #ifdef DOXYGEN
-  template <typename GR, typename CAP, typename TR>
+  template <typename GR, typename CM, typename TR>
 #else
   template <typename GR,
-            typename CAP = typename GR::template ArcMap<int>,
-            typename TR = PreflowDefaultTraits<GR, CAP> >
+            typename CM = typename GR::template ArcMap<int>,
+            typename TR = PreflowDefaultTraits<GR, CM> >
 #endif
   class Preflow {
@@ -196,7 +195,7 @@
     ///@{
 
-    template <typename T>
+    template <typename _FlowMap>
     struct SetFlowMapTraits : public Traits {
-      typedef T FlowMap;
+      typedef _FlowMap FlowMap;
       static FlowMap *createFlowMap(const Digraph&) {
         LEMON_ASSERT(false, "FlowMap is not initialized");
@@ -210,14 +209,14 @@
     /// \ref named-templ-param "Named parameter" for setting FlowMap
     /// type.
-    template <typename T>
+    template <typename _FlowMap>
     struct SetFlowMap
-      : public Preflow<Digraph, CapacityMap, SetFlowMapTraits<T> > {
+      : public Preflow<Digraph, CapacityMap, SetFlowMapTraits<_FlowMap> > {
       typedef Preflow<Digraph, CapacityMap,
-                      SetFlowMapTraits<T> > Create;
+                      SetFlowMapTraits<_FlowMap> > Create;
     };
 
-    template <typename T>
+    template <typename _Elevator>
     struct SetElevatorTraits : public Traits {
-      typedef T Elevator;
+      typedef _Elevator Elevator;
       static Elevator *createElevator(const Digraph&, int) {
         LEMON_ASSERT(false, "Elevator is not initialized");
@@ -235,14 +234,14 @@
     /// \ref run() or \ref init().
     /// \sa SetStandardElevator
-    template <typename T>
+    template <typename _Elevator>
     struct SetElevator
-      : public Preflow<Digraph, CapacityMap, SetElevatorTraits<T> > {
+      : public Preflow<Digraph, CapacityMap, SetElevatorTraits<_Elevator> > {
       typedef Preflow<Digraph, CapacityMap,
-                      SetElevatorTraits<T> > Create;
+                      SetElevatorTraits<_Elevator> > Create;
     };
 
-    template <typename T>
+    template <typename _Elevator>
     struct SetStandardElevatorTraits : public Traits {
-      typedef T Elevator;
+      typedef _Elevator Elevator;
       static Elevator *createElevator(const Digraph& digraph, int max_level) {
         return new Elevator(digraph, max_level);
@@ -262,10 +261,10 @@
     /// before calling \ref run() or \ref init().
     /// \sa SetElevator
-    template <typename T>
+    template <typename _Elevator>
     struct SetStandardElevator
       : public Preflow<Digraph, CapacityMap,
-                       SetStandardElevatorTraits<T> > {
+                       SetStandardElevatorTraits<_Elevator> > {
       typedef Preflow<Digraph, CapacityMap,
-                      SetStandardElevatorTraits<T> > Create;
+                      SetStandardElevatorTraits<_Elevator> > Create;
     };
 
@@ -405,5 +404,5 @@
       _phase = true;
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        (*_excess)[n] = 0;
+        _excess->set(n, 0);
       }
 
@@ -418,8 +417,8 @@
 
       std::vector<Node> queue;
-      reached[_source] = true;
+      reached.set(_source, true);
 
       queue.push_back(_target);
-      reached[_target] = true;
+      reached.set(_target, true);
       while (!queue.empty()) {
         _level->initNewLevel();
@@ -430,5 +429,5 @@
             Node u = _graph.source(e);
             if (!reached[u] && _tolerance.positive((*_capacity)[e])) {
-              reached[u] = true;
+              reached.set(u, true);
               _level->initAddItem(u);
               nqueue.push_back(u);
@@ -445,5 +444,5 @@
           if ((*_level)[u] == _level->maxLevel()) continue;
           _flow->set(e, (*_capacity)[e]);
-          (*_excess)[u] += (*_capacity)[e];
+          _excess->set(u, (*_excess)[u] + (*_capacity)[e]);
           if (u != _target && !_level->active(u)) {
             _level->activate(u);
@@ -479,5 +478,5 @@
         }
         if (excess < 0 && n != _source) return false;
-        (*_excess)[n] = excess;
+        _excess->set(n, excess);
       }
 
@@ -488,8 +487,8 @@
 
       std::vector<Node> queue;
-      reached[_source] = true;
+      reached.set(_source, true);
 
       queue.push_back(_target);
-      reached[_target] = true;
+      reached.set(_target, true);
       while (!queue.empty()) {
         _level->initNewLevel();
@@ -501,5 +500,5 @@
             if (!reached[u] &&
                 _tolerance.positive((*_capacity)[e] - (*_flow)[e])) {
-              reached[u] = true;
+              reached.set(u, true);
               _level->initAddItem(u);
               nqueue.push_back(u);
@@ -509,5 +508,5 @@
             Node v = _graph.target(e);
             if (!reached[v] && _tolerance.positive((*_flow)[e])) {
-              reached[v] = true;
+              reached.set(v, true);
               _level->initAddItem(v);
               nqueue.push_back(v);
@@ -525,5 +524,5 @@
           if ((*_level)[u] == _level->maxLevel()) continue;
           _flow->set(e, (*_capacity)[e]);
-          (*_excess)[u] += rem;
+          _excess->set(u, (*_excess)[u] + rem);
           if (u != _target && !_level->active(u)) {
             _level->activate(u);
@@ -537,5 +536,5 @@
           if ((*_level)[v] == _level->maxLevel()) continue;
           _flow->set(e, 0);
-          (*_excess)[v] += rem;
+          _excess->set(v, (*_excess)[v] + rem);
           if (v != _target && !_level->active(v)) {
             _level->activate(v);
@@ -578,10 +577,10 @@
               if (!_tolerance.less(rem, excess)) {
                 _flow->set(e, (*_flow)[e] + excess);
-                (*_excess)[v] += excess;
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push_1;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
+                _excess->set(v, (*_excess)[v] + rem);
                 _flow->set(e, (*_capacity)[e]);
               }
@@ -601,10 +600,10 @@
               if (!_tolerance.less(rem, excess)) {
                 _flow->set(e, (*_flow)[e] - excess);
-                (*_excess)[v] += excess;
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push_1;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
+                _excess->set(v, (*_excess)[v] + rem);
                 _flow->set(e, 0);
               }
@@ -616,5 +615,5 @@
         no_more_push_1:
 
-          (*_excess)[n] = excess;
+          _excess->set(n, excess);
 
           if (excess != 0) {
@@ -651,10 +650,10 @@
               if (!_tolerance.less(rem, excess)) {
                 _flow->set(e, (*_flow)[e] + excess);
-                (*_excess)[v] += excess;
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push_2;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
+                _excess->set(v, (*_excess)[v] + rem);
                 _flow->set(e, (*_capacity)[e]);
               }
@@ -674,10 +673,10 @@
               if (!_tolerance.less(rem, excess)) {
                 _flow->set(e, (*_flow)[e] - excess);
-                (*_excess)[v] += excess;
+                _excess->set(v, (*_excess)[v] + excess);
                 excess = 0;
                 goto no_more_push_2;
               } else {
                 excess -= rem;
-                (*_excess)[v] += rem;
+                _excess->set(v, (*_excess)[v] + rem);
                 _flow->set(e, 0);
               }
@@ -689,5 +688,5 @@
         no_more_push_2:
 
-          (*_excess)[n] = excess;
+          _excess->set(n, excess);
 
           if (excess != 0) {
@@ -732,5 +731,5 @@
       typename Digraph::template NodeMap<bool> reached(_graph);
       for (NodeIt n(_graph); n != INVALID; ++n) {
-        reached[n] = (*_level)[n] < _level->maxLevel();
+        reached.set(n, (*_level)[n] < _level->maxLevel());
       }
 
@@ -740,5 +739,5 @@
       std::vector<Node> queue;
       queue.push_back(_source);
-      reached[_source] = true;
+      reached.set(_source, true);
 
       while (!queue.empty()) {
@@ -750,5 +749,5 @@
             Node v = _graph.target(e);
             if (!reached[v] && _tolerance.positive((*_flow)[e])) {
-              reached[v] = true;
+              reached.set(v, true);
               _level->initAddItem(v);
               nqueue.push_back(v);
@@ -759,5 +758,5 @@
             if (!reached[u] &&
                 _tolerance.positive((*_capacity)[e] - (*_flow)[e])) {
-              reached[u] = true;
+              reached.set(u, true);
               _level->initAddItem(u);
               nqueue.push_back(u);
@@ -793,10 +792,10 @@
             if (!_tolerance.less(rem, excess)) {
               _flow->set(e, (*_flow)[e] + excess);
-              (*_excess)[v] += excess;
+              _excess->set(v, (*_excess)[v] + excess);
               excess = 0;
               goto no_more_push;
             } else {
               excess -= rem;
-              (*_excess)[v] += rem;
+              _excess->set(v, (*_excess)[v] + rem);
               _flow->set(e, (*_capacity)[e]);
             }
@@ -816,10 +815,10 @@
             if (!_tolerance.less(rem, excess)) {
               _flow->set(e, (*_flow)[e] - excess);
-              (*_excess)[v] += excess;
+              _excess->set(v, (*_excess)[v] + excess);
               excess = 0;
               goto no_more_push;
             } else {
               excess -= rem;
-              (*_excess)[v] += rem;
+              _excess->set(v, (*_excess)[v] + rem);
               _flow->set(e, 0);
             }
@@ -831,5 +830,5 @@
       no_more_push:
 
-        (*_excess)[n] = excess;
+        _excess->set(n, excess);
 
         if (excess != 0) {
@@ -948,5 +947,5 @@
     ///
     /// \note This function calls \ref minCut() for each node, so it runs in
-    /// O(n) time.
+    /// \f$O(n)\f$ time.
     ///
     /// \pre Either \ref run() or \ref init() must be called before
Index: lemon/radix_sort.h
===================================================================
--- lemon/radix_sort.h	(revision 559)
+++ lemon/radix_sort.h	(revision 444)
@@ -206,9 +206,9 @@
   ///
   /// This is a special quick sort algorithm where the pivot
-  /// values to split the items are choosen to be 2<sup>k</sup>
-  /// for each \c k.
-  /// Therefore, the time complexity of the algorithm is O(log(c)*n) and
-  /// it uses O(log(c)) additional space, where \c c is the maximal value
-  /// and \c n is the number of the items in the container.
+  /// values to split the items are choosen to be \f$ 2^k \f$ for each \c k.
+  /// Therefore, the time complexity of the
+  /// algorithm is \f$ O(\log(c)n) \f$ and it uses \f$ O(\log(c)) \f$,
+  /// additional space, where \c c is the maximal value and \c n is the
+  /// number of the items in the container.
   ///
   /// \param first The begin of the given range.
@@ -431,8 +431,8 @@
   /// byte-by-byte. First, it counts how many times a byte value occurs
   /// in the container, then it copies the corresponding items to
-  /// another container in asceding order in O(n) time.
-  ///
-  /// The time complexity of the algorithm is O(log(c)*n) and
-  /// it uses O(n) additional space, where \c c is the
+  /// another container in asceding order in \c O(n) time.
+  ///
+  /// The time complexity of the algorithm is \f$ O(\log(c)n) \f$ and
+  /// it uses \f$ O(n) \f$, additional space, where \c c is the
   /// maximal value and \c n is the number of the items in the
   /// container.
Index: lemon/random.h
===================================================================
--- lemon/random.h	(revision 584)
+++ lemon/random.h	(revision 517)
@@ -604,5 +604,5 @@
     /// function with the <tt>/dev/urandom</tt> file. If it does not success,
     /// it uses the \c seedFromTime().
-    /// \return Currently always \c true.
+    /// \return Currently always true.
     bool seed() {
 #ifndef WIN32
@@ -625,5 +625,5 @@
     /// \param file The source file
     /// \param offset The offset, from the file read.
-    /// \return \c true when the seeding successes.
+    /// \return True when the seeding successes.
 #ifndef WIN32
     bool seedFromFile(const std::string& file = "/dev/urandom", int offset = 0)
@@ -646,5 +646,5 @@
     /// current process id and the current time for initialize the
     /// random sequence.
-    /// \return Currently always \c true.
+    /// \return Currently always true.
     bool seedFromTime() {
 #ifndef WIN32
@@ -660,5 +660,5 @@
     /// @}
 
-    ///\name Uniform Distributions
+    ///\name Uniform distributions
     ///
     /// @{
@@ -763,5 +763,5 @@
     /// @}
 
-    ///\name Non-uniform Distributions
+    ///\name Non-uniform distributions
     ///
     ///@{
@@ -939,5 +939,5 @@
     ///@}
 
-    ///\name Two Dimensional Distributions
+    ///\name Two dimensional distributions
     ///
     ///@{
Index: lemon/smart_graph.h
===================================================================
--- lemon/smart_graph.h	(revision 582)
+++ lemon/smart_graph.h	(revision 440)
@@ -192,5 +192,7 @@
   ///that <b> it does support only limited (only stack-like)
   ///node and arc deletions</b>.
-  ///It fully conforms to the \ref concepts::Digraph "Digraph concept".
+  ///It conforms to the \ref concepts::Digraph "Digraph concept" with
+  ///an important extra feature that its maps are real \ref
+  ///concepts::ReferenceMap "reference map"s.
   ///
   ///\sa concepts::Digraph.
@@ -224,6 +226,6 @@
     ///Add a new node to the digraph.
 
-    /// Add a new node to the digraph.
-    /// \return The new node.
+    /// \return the new node.
+    ///
     Node addNode() { return Parent::addNode(); }
 
@@ -232,5 +234,5 @@
     ///Add a new arc to the digraph with source node \c s
     ///and target node \c t.
-    ///\return The new arc.
+    ///\return the new arc.
     Arc addArc(const Node& s, const Node& t) {
       return Parent::addArc(s, t);
@@ -628,7 +630,13 @@
   /// that <b> it does support only limited (only stack-like)
   /// node and arc deletions</b>.
-  /// It fully conforms to the \ref concepts::Graph "Graph concept".
+  /// Except from this it conforms to
+  /// the \ref concepts::Graph "Graph concept".
+  ///
+  /// It also has an
+  /// important extra feature that
+  /// its maps are real \ref concepts::ReferenceMap "reference map"s.
   ///
   /// \sa concepts::Graph.
+  ///
   class SmartGraph : public ExtendedSmartGraphBase {
   private:
@@ -659,6 +667,6 @@
     ///Add a new node to the graph.
 
-    /// Add a new node to the graph.
-    /// \return The new node.
+    /// \return the new node.
+    ///
     Node addNode() { return Parent::addNode(); }
 
@@ -667,5 +675,5 @@
     ///Add a new edge to the graph with node \c s
     ///and \c t.
-    ///\return The new edge.
+    ///\return the new edge.
     Edge addEdge(const Node& s, const Node& t) {
       return Parent::addEdge(s, t);
Index: lemon/soplex.cc
===================================================================
--- lemon/soplex.cc	(revision 576)
+++ lemon/soplex.cc	(revision 462)
@@ -20,6 +20,5 @@
 #include <lemon/soplex.h>
 
-#include <soplex.h>
-#include <spxout.h>
+#include <soplex/soplex.h>
 
 
@@ -30,5 +29,4 @@
   SoplexLp::SoplexLp() {
     soplex = new soplex::SoPlex;
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -50,5 +48,4 @@
     _row_names_ref = lp._row_names_ref;
 
-    messageLevel(MESSAGE_NOTHING);
   }
 
@@ -58,10 +55,10 @@
   }
 
-  SoplexLp* SoplexLp::newSolver() const {
+  SoplexLp* SoplexLp::_newSolver() const {
     SoplexLp* newlp = new SoplexLp();
     return newlp;
   }
 
-  SoplexLp* SoplexLp::cloneSolver() const {
+  SoplexLp* SoplexLp::_cloneSolver() const {
     SoplexLp* newlp = new SoplexLp(*this);
     return newlp;
@@ -275,6 +272,4 @@
 
     _clear_temporals();
-    
-    _applyMessageLevel();
 
     soplex::SPxSolver::Status status = soplex->solve();
@@ -425,28 +420,4 @@
   }
 
-  void SoplexLp::_messageLevel(MessageLevel level) {
-    switch (level) {
-    case MESSAGE_NOTHING:
-      _message_level = -1;
-      break;
-    case MESSAGE_ERROR:
-      _message_level = soplex::SPxOut::ERROR;
-      break;
-    case MESSAGE_WARNING:
-      _message_level = soplex::SPxOut::WARNING;
-      break;
-    case MESSAGE_NORMAL:
-      _message_level = soplex::SPxOut::INFO2;
-      break;
-    case MESSAGE_VERBOSE:
-      _message_level = soplex::SPxOut::DEBUG;
-      break;
-    }
-  }
-
-  void SoplexLp::_applyMessageLevel() {
-    soplex::Param::setVerbose(_message_level);
-  }
-
 } //namespace lemon
 
Index: lemon/soplex.h
===================================================================
--- lemon/soplex.h	(revision 576)
+++ lemon/soplex.h	(revision 462)
@@ -74,10 +74,9 @@
     /// \e
     ~SoplexLp();
-    /// \e
-    virtual SoplexLp* newSolver() const;
-    /// \e
-    virtual SoplexLp* cloneSolver() const;
 
   protected:
+
+    virtual SoplexLp* _newSolver() const;
+    virtual SoplexLp* _cloneSolver() const;
 
     virtual const char* _solverName() const;
@@ -145,9 +144,4 @@
     virtual void _clear();
 
-    void _messageLevel(MessageLevel m);
-    void _applyMessageLevel();
-
-    int _message_level;
-
   };
 
Index: lemon/suurballe.h
===================================================================
--- lemon/suurballe.h	(revision 584)
+++ lemon/suurballe.h	(revision 519)
@@ -46,7 +46,7 @@
   /// \ref CapacityScaling "successive shortest path" algorithm.
   ///
-  /// \tparam GR The digraph type the algorithm runs on.
+  /// \tparam Digraph The digraph type the algorithm runs on.
   /// The default value is \c ListDigraph.
-  /// \tparam LEN The type of the length (cost) map.
+  /// \tparam LengthMap The type of the length (cost) map.
   /// The default value is <tt>Digraph::ArcMap<int></tt>.
   ///
@@ -56,24 +56,19 @@
   /// with \ref SplitNodes.
 #ifdef DOXYGEN
-  template <typename GR, typename LEN>
+  template <typename Digraph, typename LengthMap>
 #else
-  template < typename GR = ListDigraph,
-             typename LEN = typename GR::template ArcMap<int> >
+  template < typename Digraph = ListDigraph,
+             typename LengthMap = typename Digraph::template ArcMap<int> >
 #endif
   class Suurballe
   {
-    TEMPLATE_DIGRAPH_TYPEDEFS(GR);
-
+    TEMPLATE_DIGRAPH_TYPEDEFS(Digraph);
+
+    typedef typename LengthMap::Value Length;
     typedef ConstMap<Arc, int> ConstArcMap;
-    typedef typename GR::template NodeMap<Arc> PredMap;
+    typedef typename Digraph::template NodeMap<Arc> PredMap;
 
   public:
 
-    /// The type of the digraph the algorithm runs on.
-    typedef GR Digraph;
-    /// The type of the length map.
-    typedef LEN LengthMap;
-    /// The type of the lengths.
-    typedef typename LengthMap::Value Length;
     /// The type of the flow map.
     typedef typename Digraph::template ArcMap<int> FlowMap;
@@ -262,5 +257,5 @@
     /// the found arc-disjoint paths.
     ///
-    /// \return <tt>(*this)</tt>
+    /// \return \c (*this)
     Suurballe& flowMap(FlowMap &map) {
       if (_local_flow) {
@@ -279,5 +274,5 @@
     /// minimum cost flow problem.
     ///
-    /// \return <tt>(*this)</tt>
+    /// \return \c (*this)
     Suurballe& potentialMap(PotentialMap &map) {
       if (_local_potential) {
@@ -289,5 +284,5 @@
     }
 
-    /// \name Execution Control
+    /// \name Execution control
     /// The simplest way to execute the algorithm is to call the run()
     /// function.
@@ -464,5 +459,5 @@
     ///
     /// This function returns the total length (cost) of the found paths
-    /// (flow). The complexity of the function is O(e).
+    /// (flow). The complexity of the function is \f$ O(e) \f$.
     ///
     /// \pre \ref run() or \ref findFlow() must be called before using
Index: lemon/time_measure.h
===================================================================
--- lemon/time_measure.h	(revision 584)
+++ lemon/time_measure.h	(revision 515)
@@ -203,5 +203,5 @@
   };
 
-  inline TimeStamp operator*(double b,const TimeStamp &t)
+  TimeStamp operator*(double b,const TimeStamp &t)
   {
     return t*b;
@@ -288,5 +288,5 @@
     Timer(bool run=true) :_running(run) {_reset();}
 
-    ///\name Control the State of the Timer
+    ///\name Control the state of the timer
     ///Basically a Timer can be either running or stopped,
     ///but it provides a bit finer control on the execution.
@@ -396,5 +396,5 @@
     ///@}
 
-    ///\name Query Functions for the Ellapsed Time
+    ///\name Query Functions for the ellapsed time
 
     ///@{
Index: lemon/unionfind.h
===================================================================
--- lemon/unionfind.h	(revision 559)
+++ lemon/unionfind.h	(revision 440)
@@ -52,11 +52,9 @@
   /// \pre You need to add all the elements by the \ref insert()
   /// method.
-  template <typename IM>
+  template <typename _ItemIntMap>
   class UnionFind {
   public:
 
-    ///\e
-    typedef IM ItemIntMap;
-    ///\e
+    typedef _ItemIntMap ItemIntMap;
     typedef typename ItemIntMap::Key Item;
 
@@ -173,11 +171,9 @@
   /// method.
   ///
-  template <typename IM>
+  template <typename _ItemIntMap>
   class UnionFindEnum {
   public:
 
-    ///\e
-    typedef IM ItemIntMap;
-    ///\e
+    typedef _ItemIntMap ItemIntMap;
     typedef typename ItemIntMap::Key Item;
 
@@ -632,11 +628,9 @@
   /// \pre You need to add all the elements by the \ref insert()
   /// method.
-  template <typename IM>
+  template <typename _ItemIntMap>
   class ExtendFindEnum {
   public:
 
-    ///\e
-    typedef IM ItemIntMap;
-    ///\e
+    typedef _ItemIntMap ItemIntMap;
     typedef typename ItemIntMap::Key Item;
 
@@ -955,16 +949,16 @@
   /// \pre You need to add all the elements by the \ref insert()
   /// method.
-  template <typename V, typename IM, typename Comp = std::less<V> >
+  ///
+  template <typename _Value, typename _ItemIntMap,
+            typename _Comp = std::less<_Value> >
   class HeapUnionFind {
   public:
 
-    ///\e
-    typedef V Value;
-    ///\e
-    typedef typename IM::Key Item;
-    ///\e
-    typedef IM ItemIntMap;
-    ///\e
-    typedef Comp Compare;
+    typedef _Value Value;
+    typedef typename _ItemIntMap::Key Item;
+
+    typedef _ItemIntMap ItemIntMap;
+
+    typedef _Comp Comp;
 
   private:
@@ -1608,5 +1602,5 @@
     /// \brief Gives back the priority of the current item.
     ///
-    /// Gives back the priority of the current item.
+    /// \return Gives back the priority of the current item.
     const Value& operator[](const Item& item) const {
       return nodes[index[item]].prio;
@@ -1653,5 +1647,5 @@
     /// \brief Gives back the minimum priority of the class.
     ///
-    /// Gives back the minimum priority of the class.
+    /// \return Gives back the minimum priority of the class.
     const Value& classPrio(int cls) const {
       return nodes[~(classes[cls].parent)].prio;
@@ -1667,7 +1661,7 @@
     /// \brief Gives back a representant item of the class.
     ///
-    /// Gives back a representant item of the class.
     /// The representant is indpendent from the priorities of the
     /// items.
+    /// \return Gives back a representant item of the class.
     const Item& classRep(int id) const {
       int parent = classes[id].parent;
Index: m4/lx_check_clp.m4
===================================================================
--- m4/lx_check_clp.m4	(revision 459)
+++ m4/lx_check_clp.m4	(revision 459)
@@ -0,0 +1,73 @@
+AC_DEFUN([LX_CHECK_CLP],
+[
+  AC_ARG_WITH([clp],
+AS_HELP_STRING([--with-clp@<:@=PREFIX@:>@], [search for CLP under PREFIX or under the default search paths if PREFIX is not given @<:@default@:>@])
+AS_HELP_STRING([--without-clp], [disable checking for CLP]),
+              [], [with_clp=yes])
+
+  AC_ARG_WITH([clp-includedir],
+AS_HELP_STRING([--with-clp-includedir=DIR], [search for CLP headers in DIR]),
+              [], [with_clp_includedir=no])
+
+  AC_ARG_WITH([clp-libdir],
+AS_HELP_STRING([--with-clp-libdir=DIR], [search for CLP libraries in DIR]),
+              [], [with_clp_libdir=no])
+
+  lx_clp_found=no
+  if test x"$with_clp" != x"no"; then
+    AC_MSG_CHECKING([for CLP])
+
+    if test x"$with_clp_includedir" != x"no"; then
+      CLP_CXXFLAGS="-I$with_clp_includedir"
+    elif test x"$with_clp" != x"yes"; then
+      CLP_CXXFLAGS="-I$with_clp/include"
+    fi
+
+    if test x"$with_clp_libdir" != x"no"; then
+      CLP_LDFLAGS="-L$with_clp_libdir"
+    elif test x"$with_clp" != x"yes"; then
+      CLP_LDFLAGS="-L$with_clp/lib"
+    fi
+    CLP_LIBS="-lClp -lCoinUtils -lm"
+
+    lx_save_cxxflags="$CXXFLAGS"
+    lx_save_ldflags="$LDFLAGS"
+    lx_save_libs="$LIBS"
+    CXXFLAGS="$CLP_CXXFLAGS"
+    LDFLAGS="$CLP_LDFLAGS"
+    LIBS="$CLP_LIBS"
+
+    lx_clp_test_prog='
+      #include <coin/ClpModel.hpp>
+
+      int main(int argc, char** argv)
+      {
+        ClpModel clp;
+        return 0;
+      }'
+
+    AC_LANG_PUSH(C++)
+    AC_LINK_IFELSE([$lx_clp_test_prog], [lx_clp_found=yes], [lx_clp_found=no])
+    AC_LANG_POP(C++)
+
+    CXXFLAGS="$lx_save_cxxflags"
+    LDFLAGS="$lx_save_ldflags"
+    LIBS="$lx_save_libs"
+
+    if test x"$lx_clp_found" = x"yes"; then
+      AC_DEFINE([HAVE_CLP], [1], [Define to 1 if you have CLP.])
+      lx_lp_found=yes
+      AC_DEFINE([HAVE_LP], [1], [Define to 1 if you have any LP solver.])
+      AC_MSG_RESULT([yes])
+    else
+      CLP_CXXFLAGS=""
+      CLP_LDFLAGS=""
+      CLP_LIBS=""
+      AC_MSG_RESULT([no])
+    fi
+  fi
+  CLP_LIBS="$CLP_LDFLAGS $CLP_LIBS"
+  AC_SUBST(CLP_CXXFLAGS)
+  AC_SUBST(CLP_LIBS)
+  AM_CONDITIONAL([HAVE_CLP], [test x"$lx_clp_found" = x"yes"])
+])
Index: m4/lx_check_soplex.m4
===================================================================
--- m4/lx_check_soplex.m4	(revision 539)
+++ m4/lx_check_soplex.m4	(revision 457)
@@ -21,5 +21,5 @@
       SOPLEX_CXXFLAGS="-I$with_soplex_includedir"
     elif test x"$with_soplex" != x"yes"; then
-      SOPLEX_CXXFLAGS="-I$with_soplex/src"
+      SOPLEX_CXXFLAGS="-I$with_soplex/include"
     fi
 
@@ -39,5 +39,5 @@
 
     lx_soplex_test_prog='
-      #include <soplex.h>
+      #include <soplex/soplex.h>
 
       int main(int argc, char** argv)
